-- **************************************************
-- MEDICAL NOTE:
-- So you've decided to look at my code? 
-- Then you might suffer from the following affliction: http://en.wikipedia.org/wiki/Masochistic_personality_disorder
--
-- Please consult your physician before attempting to make sense of the following madness.
-- **************************************************

-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_point_time"

-- **************************************************
-- General information about this script
-- **************************************************

DS_point_time = {}


function DS_point_time:Name()
	return "Point Time Machine"
end

function DS_point_time:Version()
	return "1.3"
end


function DS_point_time:Description()
	return "Move mouse horizontally to get value. Hold shift to change selection speed."
end


function DS_point_time:Creator()
	return "dauid.com"
end

function DS_point_time:UILabel()
	return "Point Time Machine"
end



-- **************************************************
-- Recurring values
-- **************************************************
DS_point_time.doPoint=true
DS_point_time.doCurve=true
-- **************************************************
-- The guts of this script
-- **************************************************

function DS_point_time:IsEnabled(moho)
	if (moho.layer:LayerType() ~= MOHO.LT_VECTOR) then
		return false
	else
		return true
	end
end

function DS_point_time:OnMouseDown(moho, mouseEvent)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()
	self.doFrame=self.frameBox:Value()
	self.doCurve=self.curveBox:Value()
	editFrame=self.startframeNR:Value()
	curFrame=moho.layer:CurFrame()
	--mesh:PrepMovePoints()
end


function DS_point_time:OnMouseMoved(moho, mouseEvent)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	mouseGenValue=mouseEvent.pt.x-mouseEvent.startPt.x

	if (self.doFrame==true) then
		if (mouseEvent.shiftKey) then
		newFrame=editFrame+math.floor(mouseGenValue)
		else
		newFrame=editFrame+math.floor(mouseGenValue/10)
		end
	else
		if (mouseEvent.shiftKey) then
		newFrame=curFrame+math.floor(mouseGenValue)
		else
		newFrame=curFrame+math.floor(mouseGenValue/10)
		end
	end
	
	
	if newFrame<0 then
	newFrame=0
	end
	local curve = nil
	local ptPos = -1
		for i = 0, mesh:CountPoints() - 1 do
			local pt = mesh:Point(i)
			if (pt.fSelected) then
			
				if  (self.doPoint==true) then
					pt.fAnimPos:SetValue(curFrame, pt.fAnimPos:GetValue(newFrame))

				end
					if  (self.doCurve==true) then --If we want the curve info
							for j = 0, pt:CountCurves() - 1 do
							curve, ptPos = pt:Curve(j, ptPos) --Don't even understand this but it seems to work...
							local curvature = curve:GetCurvature(ptPos, newFrame)
							curve:SetCurvature(ptPos, curvature, curFrame)
							end
					end
					
						
					
				self.frameNR:SetValue(newFrame)
				
			end
		end
		moho:SetCurFrame(curFrame+1) --The bastard won't update the changes unless you scrub the timeline so this sort of fixes that
		moho:SetCurFrame(curFrame)
		mouseEvent.view:DrawMe()	
end





function DS_point_time:OnMouseUp(moho, mouseEvent, view)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

		if  (self.doPoint==true) then
		
		moho:NewKeyframe(CHANNEL_POINT)
		--moho:AddPointKeyframe(moho.frame)
		end
		if  (self.doCurve==true) then
		moho:NewKeyframe(CHANNEL_CURVE)
		end
		moho:UpdateSelectedChannels()

		mouseEvent.view:Refresh()
end



function DS_point_time:SetIt(moho, theValue)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	moho.document:PrepUndo(moho.layer)
	moho.document:SetDirty()
	self.doFrame=self.frameBox:Value()
	self.doCurve=self.curveBox:Value()
	editFrame=self.startframeNR:Value()
	curFrame=moho.layer:CurFrame()

	newFrame=self.frameNR:Value()
	
	local curve = nil
	local ptPos = -1
		for i = 0, mesh:CountPoints() - 1 do
			local pt = mesh:Point(i)
			if (pt.fSelected) then
			
				if  (self.doPoint==true) then
					pt.fAnimPos:SetValue(curFrame, pt.fAnimPos:GetValue(newFrame))

				end
					if  (self.doCurve==true) then --If we want the curve info
							for j = 0, pt:CountCurves() - 1 do
							curve, ptPos = pt:Curve(j, ptPos) --Don't even understand this but it seems to work...
							local curvature = curve:GetCurvature(ptPos, newFrame)
							curve:SetCurvature(ptPos, curvature, curFrame)
							end
					end
					
				
			end
		end
		moho:SetCurFrame(curFrame+1)
		moho:SetCurFrame(curFrame)
		
		moho.view:DrawMe()
		
		if  (self.doPoint==true) then
		
		moho:NewKeyframe(CHANNEL_POINT)
		end
		if  (self.doCurve==true) then
		moho:NewKeyframe(CHANNEL_CURVE)
		end
		moho:UpdateSelectedChannels()
		
end

function DS_point_time:SelAll(moho)
local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end
	mesh:SelectAll()
	
end
----------------------------------------------------------------Menu

DS_point_time.SETIT = MOHO.MSG_BASE
DS_point_time.SELALL = MOHO.MSG_BASE+1
DS_point_time.FRAME = MOHO.MSG_BASE+2
DS_point_time.DUMMY = MOHO.MSG_BASE + 3
DS_point_time.CURVE = MOHO.MSG_BASE + 4
DS_point_time.POINT = MOHO.MSG_BASE + 5
DS_point_time.SELECTITEM= MOHO.MSG_BASE+6

function DS_point_time:DoLayout(moho, layout)

	self.menu = LM.GUI.Menu("Select group")

	self.popup = LM.GUI.PopupMenu(128, false)
	self.popup:SetMenu(self.menu)
	layout:AddChild(self.popup)


	self.selBut= LM.GUI.Button("Select all points", self.SELALL)
	layout:AddChild(self.selBut)
	self.theText=LM.GUI.StaticText("Get value from frame:")
	layout:AddChild(self.theText)
	self.frameNR = LM.GUI.TextControl(0, "Big ole text   ", 0, LM.GUI.FIELD_INT)
	self.frameNR:SetValue(0)
	layout:AddChild(self.frameNR)
	self.setBut= LM.GUI.Button("Set", self.SETIT)
	layout:AddChild(self.setBut)
	
	self.pointBox = LM.GUI.CheckBox("Get point motion", self.POINT)
	layout:AddChild(self.pointBox)
	self.pointBox:SetValue(true)
	
	self.curveBox = LM.GUI.CheckBox("Get curvature", self.CURVE)
	layout:AddChild(self.curveBox)
	self.curveBox:SetValue(true)
	
	self.frameBox = LM.GUI.CheckBox("Always start on frame:", self.FRAME)
	layout:AddChild(self.frameBox)
	
	self.startframeNR = LM.GUI.TextControl(0, "000", 0, LM.GUI.FIELD_INT)
	self.startframeNR:SetValue(0)
	layout:AddChild(self.startframeNR)
end

function DS_point_time:UpdateWidgets(moho)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	MOHO.BuildGroupMenu(self.menu, mesh, self.SELECTITEM, self.DUMMY)
end

function DS_point_time:HandleMessage(moho, view, msg)
	local mesh = moho:Mesh()
	if (mesh == nil) then
		return
	end

	if (msg == self.SETIT) then
		DS_point_time:SetIt(moho, self.frameNR:IntValue())
	end
	if (msg == self.SELALL) then
		DS_point_time:SelAll(moho)
	end
	if (msg == self.FRAME) then
		self.doFrame=self.frameBox:Value()
	end
	if (msg == self.CURVE) then
		self.doCurve=self.curveBox:Value()
	end
	if (msg == self.POINT) then
		self.doPoint=self.pointBox:Value()
	end
	if (msg >= self.SELECTITEM) then
		mesh:SelectNone()
		local i = msg - self.SELECTITEM
		local name = mesh:Group(i):Name()
		mesh:SelectGroup(name)
		moho:UpdateUI()
	end

end
